﻿<Graph ClassName="SFDisattachSOProcess" Source="#CDATA" IsNew="True" FileType="NewGraph">
    <CDATA name="Source"><![CDATA[using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using PX.Data;
using PX.Objects.SO;

namespace SF
{
	public class SFDisattachSOProcess : PXGraph<SFDisattachSOProcess>
	{
		public PXCancel<SOLine> Cancel;

		public PXProcessingJoin<
		    SOLine, 
		    InnerJoin<SOOrder, 
		        On<SOOrder.orderType, Equal<SOLine.orderType>, 
		        And<SOOrder.orderNbr, Equal<SOLine.orderNbr>>>,
		    InnerJoin<SFSOLineContent, 
		        On<SFSOLineContent.orderType, Equal<SOLine.orderType>,
		        And<SFSOLineContent.orderNbr, Equal<SOLine.orderNbr>,
		        And<SFSOLineContent.sOLineNbr, Equal<SOLine.lineNbr>>>>>>> 
		    SOToDisattach;

		public virtual IEnumerable sOToDisattach()
		{
			List<SOLine> soLines = new List<SOLine>();

			foreach (PXResult<SOLine, SOOrder, SFSOLineContent> res in PXSelectJoin<
			    SOLine,
			    InnerJoin<SOOrder,
			        On<SOOrder.orderType, Equal<SOLine.orderType>,
			        And<SOOrder.orderNbr, Equal<SOLine.orderNbr>>>,
			    InnerJoin<SFSOLineContent, 
			        On<SFSOLineContent.orderType, Equal<SOLine.orderType>,
			        And<SFSOLineContent.orderNbr, Equal<SOLine.orderNbr>,
			        And<SFSOLineContent.sOLineNbr, Equal<SOLine.lineNbr>>>>>>,
			    Where<SOLine.completed, Equal<True>,
			        And<SOLine.shippedQty, Less<SOLine.orderQty>>>>
			    .Select(this))
			{
				SOLine line = res;

				//[DEVELOPER NAME]: JOHN COMBATE [DATE TIME]: 2/3/2022 9:51:31 PM [PURPOSE]: MAKE SURE EACH LINE IS UNIQUE
				if (soLines.Contains(line)) continue;
				soLines.Add(line);

				//[DEVELOPER NAME]: JOHN COMBATE [DATE TIME]: 2/3/2022 9:47:06 PM [PURPOSE]: CHECK IF SHIPPED QTY IS FULLY ALLOCATED
				if (line.ShippedQty < PXSelect<
				    SFAllocation,
				    Where<SFAllocation.sOOrderNbr, Equal<Required<SFAllocation.sOOrderNbr>>,
				        And<SFAllocation.sOOrderType, Equal<Required<SFAllocation.sOOrderType>>,
				        And<SFAllocation.sOLineNbr, Equal<Required<SFAllocation.sOLineNbr>>>>>>
				    .Select(this, line.OrderNbr, line.OrderType, line.LineNbr)
				    .RowCast<SFAllocation>()
				    .Sum(sf => sf.Qty))
					yield return res;

			}
		}

		public SFDisattachSOProcess()
		{
			SOToDisattach.SetSelected<SOLineExtSF.usrSFSelected>();
			SOToDisattach.SetProcessDelegate(delegate (List<SOLine> lines)
			{
				DisattachSOLine(lines);
			});
		}

		public static void DisattachSOLine(List<SOLine> lines)
		{
			var soGraph = PXGraph.CreateInstance<SOOrderEntry>();
			var soGraphExt = soGraph.GetExtension<SOOrderEntryExtSF>();

			foreach (SOLine line in lines)
			{
				decimal? qtyToDisattach = line.OrderQty - line.ShippedQty;
				soGraph.Clear();

				soGraph.Document.Current = soGraph.Document.Search<SOOrder.orderNbr>(line.OrderNbr, line.OrderType);

				foreach (SFAllocation allocation in PXSelect<
				    SFAllocation,
				    Where<SFAllocation.sOOrderNbr, Equal<Required<SFAllocation.sOOrderNbr>>,
				        And<SFAllocation.sOOrderType, Equal<Required<SFAllocation.sOOrderType>>,
				        And<SFAllocation.sOLineNbr, Equal<Required<SFAllocation.sOLineNbr>>>>>>
				    .Select(soGraph, line.OrderNbr, line.OrderType, line.LineNbr))
				{
					if (allocation.Qty > qtyToDisattach)
					{
						soGraphExt.AllSFAllocations.Cache.SetValueExt<SFAllocation.qty>(allocation, allocation.Qty - qtyToDisattach);
						soGraphExt.AllSFAllocations.Update(allocation);

						soGraph.Persist();
						break;
					}
				}					
			}
		}
	}
}]]></CDATA>
</Graph>